
/* Chrysalide - Outil d'analyse de fichiers binaires
 * disassembler.h - prototypes pour l'encadrement des phases de désassemblage
 *
 * Copyright (C) 2010-2012 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _ANALYSIS_DISASS_DISASSEMBLER_H
#define _ANALYSIS_DISASS_DISASSEMBLER_H


#include "../binary.h"



/* ------------------------ DESASSEMBLAGE DE BINAIRE DIFFERE ------------------------ */


#define G_TYPE_DELAYED_DISASSEMBLY               g_delayed_disassembly_get_type()
#define G_DELAYED_DISASSEMBLY(obj)               (G_TYPE_CHECK_INSTANCE_CAST((obj), g_delayed_disassembly_get_type(), GDelayedDisassembly))
#define G_IS_DELAYED_DISASSEMBLY(obj)            (G_TYPE_CHECK_INSTANCE_TYPE((obj), g_delayed_disassembly_get_type()))
#define G_DELAYED_DISASSEMBLY_CLASS(klass)       (G_TYPE_CHECK_CLASS_CAST((klass), G_TYPE_DELAYED_DISASSEMBLY, GDelayedDisassemblyClass))
#define G_IS_DELAYED_DISASSEMBLY_CLASS(klass)    (G_TYPE_CHECK_CLASS_TYPE((klass), G_TYPE_DELAYED_DISASSEMBLY))
#define G_DELAYED_DISASSEMBLY_GET_CLASS(obj)     (G_TYPE_INSTANCE_GET_CLASS((obj), G_TYPE_DELAYED_DISASSEMBLY, GDelayedDisassemblyClass))


/* Ensembles binaires à désassembler (instance) */
typedef struct _GDelayedDisassembly GDelayedDisassembly;

/* Ensembles binaires à désassembler (classe) */
typedef struct _GDelayedDisassemblyClass GDelayedDisassemblyClass;


/* Indique le type défini pour les tâches de désassemblage différé. */
GType g_delayed_disassembly_get_type(void);



/* -------------------------- GESTION GLOBALE DE PROCEDURE -------------------------- */


/* Acquitte la fin d'un désasemblage différé et complet. */
typedef void (* disassembly_ack_fc) (GDelayedDisassembly *, GLoadedBinary *);

/* Procède à la décompilation des routines d'un fichier donné. */
void disassemble_binary(GLoadedBinary *, GBufferCache **, disassembly_ack_fc);



#endif  /* _ANALYSIS_DISASS_DISASSEMBLER_H */
