
/* Chrysalide - Outil d'analyse de fichiers binaires
 * content.c - intégration de données partagées
 *
 * Copyright (C) 2016 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#include "container.h"


#include <assert.h>


#include "container-int.h"



/* Procède à l'initialisation de l'interface d'intégration. */
static void g_share_container_default_init(GShareContainerInterface *);



/* Détermine le type d'une interface pour l'intégration de contenu partagé. */
G_DEFINE_INTERFACE(GShareContainer, g_share_container, G_TYPE_OBJECT)


/******************************************************************************
*                                                                             *
*  Paramètres  : iface = interface GLib à initialiser.                        *
*                                                                             *
*  Description : Procède à l'initialisation de l'interface d'intégration.     *
*                                                                             *
*  Retour      : -                                                            *
*                                                                             *
*  Remarques   : -                                                            *
*                                                                             *
******************************************************************************/

static void g_share_container_default_init(GShareContainerInterface *iface)
{

}


/******************************************************************************
*                                                                             *
*  Paramètres  : instance = intégrateur à éventuellement manipuler.           *
*                old      = ancien contenu à remplacer si besoin est.         *
*                new      = nouveau contenu, potentiellement original.        *
*                                                                             *
*  Description : Assure la mise à jour du contenu d'un intégrateur.           *
*                                                                             *
*  Retour      : -                                                            *
*                                                                             *
*  Remarques   : -                                                            *
*                                                                             *
******************************************************************************/

void g_share_container_replace(GShareContainer *container, GSharedInstance *old, GSharedInstance *new)
{
    GShareContainerIface *iface;            /* Interface utilisée          */

    if (old != new)
    {
        iface = G_SHARE_CONTAINER_GET_IFACE(container);

        iface->replace(container, old, new);

    }

}
