
/* Chrysalide - Outil d'analyse de fichiers binaires
 * data.h - prototypes pour les opérandes de manipulation de données
 *
 * Copyright (C) 2012 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _ARCH_X86_OPERANDS_DATA_H
#define _ARCH_X86_OPERANDS_DATA_H


#include <glib-object.h>


#include "../../operand.h"
#include "../../../common/endianness.h"



#define G_TYPE_X86_DATA_OPERAND                  g_x86_data_operand_get_type()
#define G_X86_DATA_OPERAND(obj)                  (G_TYPE_CHECK_INSTANCE_CAST((obj), g_x86_data_operand_get_type(), GX86DataOperand))
#define G_IS_X86_DATA_OPERAND(obj)               (G_TYPE_CHECK_INSTANCE_TYPE((obj), g_x86_data_operand_get_type()))
#define G_X86_DATA_OPERAND_CLASS(klass)          (G_TYPE_CHECK_CLASS_CAST((klass), G_TYPE_X86_DATA_OPERAND, GX86DataOperandClass))
#define G_IS_X86_DATA_OPERAND_CLASS(klass)       (G_TYPE_CHECK_CLASS_TYPE((klass), G_TYPE_X86_DATA_OPERAND))
#define G_X86_DATA_OPERAND_GET_CLASS(obj)        (G_TYPE_INSTANCE_GET_CLASS((obj), G_TYPE_X86_DATA_OPERAND, GX86DataOperandClass))



/* Définition d'un opérande x86 de manipulation de données (instance) */
typedef struct _GX86DataOperand GX86DataOperand;

/* Définition d'un opérande x86 de manipulation de données (classe) */
typedef struct _GX86DataOperandClass GX86DataOperandClass;


/* Indique le type défini par la GLib pour un opérande x86 de manipulation de données. */
GType g_x86_data_operand_get_type(void);

/* Crée un opérande x86 de manipulation de données. */
GArchOperand *g_x86_data_operand_new(MemoryDataSize, bool);



#endif  /* _ARCH_X86_OPERANDS_DATA_H */
