
/* Chrysalide - Outil d'analyse de fichiers binaires
 * pe.h - prototypes pour le support du format Portable Executable
 *
 * Copyright (C) 2009-2012 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _FORMAT_PE_PE_H
#define _FORMAT_PE_PE_H


#include <glib-object.h>
#include <stdbool.h>
#include <sys/types.h>


#include "../../core/formats.h"



#define G_TYPE_PE_FORMAT               g_pe_format_get_type()
#define G_PE_FORMAT(obj)               (G_TYPE_CHECK_INSTANCE_CAST((obj), g_pe_format_get_type(), GPeFormat))
#define G_IS_PE_FORMAT(obj)            (G_TYPE_CHECK_INSTANCE_TYPE((obj), g_pe_format_get_type()))
#define G_PE_FORMAT_GET_IFACE(inst)    (G_TYPE_INSTANCE_GET_INTERFACE((inst), g_pe_format_get_type(), GPeFormatIface))
#define G_PE_FORMAT_GET_CLASS(obj)     (G_TYPE_INSTANCE_GET_CLASS((obj), G_TYPE_PE_FORMAT, GPeFormatClass))


/* Format d'exécutable PE (instance) */
typedef struct _GPeFormat GPeFormat;

/* Format d'exécutable PE (classe) */
typedef struct _GPeFormatClass GPeFormatClass;


/* Indique si le format peut être pris en charge ici. */
bool pe_is_matching(GBinContent *);

/* Indique le type défini pour un format d'exécutable PE. */
GType g_pe_format_get_type(void);

/* Prend en charge un nouveau format PE. */
GBinFormat *g_pe_format_new(const bin_t *, off_t);



#endif  /* _FORMAT_PE_PE_H */
